package javax.swing.plaf.multi;

import javax.accessibility.Accessible;
import java.awt.Dimension;
import java.awt.Graphics;
import javax.swing.JComponent;
import java.io.File;
import javax.swing.filechooser.FileView;
import javax.swing.filechooser.FileFilter;
import javax.swing.JFileChooser;
import javax.swing.plaf.ComponentUI;
import java.util.Vector;
import javax.swing.plaf.FileChooserUI;

public class MultiFileChooserUI extends FileChooserUI
{
    protected Vector uis;
    
    public MultiFileChooserUI() {
        this.uis = new Vector();
    }
    
    public ComponentUI[] getUIs() {
        return MultiLookAndFeel.uisToArray(this.uis);
    }
    
    @Override
    public FileFilter getAcceptAllFileFilter(JFileChooser fileChooser) {
        FileFilter acceptAllFileFilter = ((FileChooserUI)(FileChooserUI)this.uis.elementAt(0)).getAcceptAllFileFilter(fileChooser);
        for (int i = 1; i < this.uis.size(); ++i) {
            ((FileChooserUI)(FileChooserUI)this.uis.elementAt(i)).getAcceptAllFileFilter(fileChooser);
        }
        return acceptAllFileFilter;
    }
    
    @Override
    public FileView getFileView(JFileChooser fileChooser) {
        FileView fileView = ((FileChooserUI)(FileChooserUI)this.uis.elementAt(0)).getFileView(fileChooser);
        for (int i = 1; i < this.uis.size(); ++i) {
            ((FileChooserUI)(FileChooserUI)this.uis.elementAt(i)).getFileView(fileChooser);
        }
        return fileView;
    }
    
    @Override
    public String getApproveButtonText(JFileChooser fileChooser) {
        String approveButtonText = ((FileChooserUI)(FileChooserUI)this.uis.elementAt(0)).getApproveButtonText(fileChooser);
        for (int i = 1; i < this.uis.size(); ++i) {
            ((FileChooserUI)(FileChooserUI)this.uis.elementAt(i)).getApproveButtonText(fileChooser);
        }
        return approveButtonText;
    }
    
    @Override
    public String getDialogTitle(JFileChooser fileChooser) {
        String dialogTitle = ((FileChooserUI)(FileChooserUI)this.uis.elementAt(0)).getDialogTitle(fileChooser);
        for (int i = 1; i < this.uis.size(); ++i) {
            ((FileChooserUI)(FileChooserUI)this.uis.elementAt(i)).getDialogTitle(fileChooser);
        }
        return dialogTitle;
    }
    
    @Override
    public void rescanCurrentDirectory(JFileChooser fileChooser) {
        for (int i = 0; i < this.uis.size(); ++i) {
            ((FileChooserUI)(FileChooserUI)this.uis.elementAt(i)).rescanCurrentDirectory(fileChooser);
        }
    }
    
    @Override
    public void ensureFileIsVisible(JFileChooser fileChooser, File file) {
        for (int i = 0; i < this.uis.size(); ++i) {
            ((FileChooserUI)(FileChooserUI)this.uis.elementAt(i)).ensureFileIsVisible(fileChooser, file);
        }
    }
    
    @Override
    public boolean contains(JComponent component, int n, int n2) {
        int contains = ((ComponentUI)(ComponentUI)this.uis.elementAt(0)).contains(component, n, n2);
        for (int i = 1; i < this.uis.size(); ++i) {
            ((ComponentUI)(ComponentUI)this.uis.elementAt(i)).contains(component, n, n2);
        }
        return contains;
    }
    
    @Override
    public void update(Graphics g, JComponent c) {
        for (int i = 0; i < this.uis.size(); ++i) {
            ((ComponentUI)(ComponentUI)this.uis.elementAt(i)).update(g, c);
        }
    }
    
    public static ComponentUI createUI(JComponent component) {
        MultiFileChooserUI multiFileChooserUI = new MultiFileChooserUI();
        return MultiLookAndFeel.createUIs(multiFileChooserUI, ((MultiFileChooserUI)multiFileChooserUI).uis, component);
    }
    
    @Override
    public void installUI(JComponent c) {
        for (int i = 0; i < this.uis.size(); ++i) {
            ((ComponentUI)(ComponentUI)this.uis.elementAt(i)).installUI(c);
        }
    }
    
    @Override
    public void uninstallUI(JComponent c) {
        for (int i = 0; i < this.uis.size(); ++i) {
            ((ComponentUI)(ComponentUI)this.uis.elementAt(i)).uninstallUI(c);
        }
    }
    
    @Override
    public void paint(Graphics g, JComponent c) {
        for (int i = 0; i < this.uis.size(); ++i) {
            ((ComponentUI)(ComponentUI)this.uis.elementAt(i)).paint(g, c);
        }
    }
    
    @Override
    public Dimension getPreferredSize(JComponent component) {
        Dimension preferredSize = ((ComponentUI)(ComponentUI)this.uis.elementAt(0)).getPreferredSize(component);
        for (int i = 1; i < this.uis.size(); ++i) {
            ((ComponentUI)(ComponentUI)this.uis.elementAt(i)).getPreferredSize(component);
        }
        return preferredSize;
    }
    
    @Override
    public Dimension getMinimumSize(JComponent component) {
        Dimension minimumSize = ((ComponentUI)(ComponentUI)this.uis.elementAt(0)).getMinimumSize(component);
        for (int i = 1; i < this.uis.size(); ++i) {
            ((ComponentUI)(ComponentUI)this.uis.elementAt(i)).getMinimumSize(component);
        }
        return minimumSize;
    }
    
    @Override
    public Dimension getMaximumSize(JComponent component) {
        Dimension maximumSize = ((ComponentUI)(ComponentUI)this.uis.elementAt(0)).getMaximumSize(component);
        for (int i = 1; i < this.uis.size(); ++i) {
            ((ComponentUI)(ComponentUI)this.uis.elementAt(i)).getMaximumSize(component);
        }
        return maximumSize;
    }
    
    @Override
    public int getAccessibleChildrenCount(JComponent component) {
        int accessibleChildrenCount = ((ComponentUI)(ComponentUI)this.uis.elementAt(0)).getAccessibleChildrenCount(component);
        for (int i = 1; i < this.uis.size(); ++i) {
            ((ComponentUI)(ComponentUI)this.uis.elementAt(i)).getAccessibleChildrenCount(component);
        }
        return accessibleChildrenCount;
    }
    
    @Override
    public Accessible getAccessibleChild(JComponent component, int n) {
        Accessible accessibleChild = ((ComponentUI)(ComponentUI)this.uis.elementAt(0)).getAccessibleChild(component, n);
        for (int i = 1; i < this.uis.size(); ++i) {
            ((ComponentUI)(ComponentUI)this.uis.elementAt(i)).getAccessibleChild(component, n);
        }
        return accessibleChild;
    }
}
